unit SHFormat;

//------------------------------------------------------------------------------
// Unit         : SHFormat
// Beschreibung : Implementation der Funktion SHFormatDrive
// Autor        : Jrgen Schwarze
// Plattform    : Microsoft Windows 95
// Compiler     : Borland Delphi 2.0
// Datum        : 13.03.1996
// Anmerkung    : Die Funktion SHFormatDrive wurde im SDK von MS Windows 95 und
//                in den Import-Units von Delphi 2.0 nicht bercksichtigt.
//                ber den Aufruf kann der Dialog aktiviert werden, den man
//                auch erhlt, wenn man auf einem Laufwerks-Symbol mit der
//                rechten Maustaste klickt und dann den Menpunkt 'Formatieren'
//                auswhlt.
//------------------------------------------------------------------------------

interface

uses

  Windows;

const

// Wert fr den Parameter fmtID der Funktion SHFormatDrive(...)

  SHFMT_ID_DEFAULT      = $FFFF;     // Standardeinstellung fr physik. Format

// Werte fr den Parameter Options der Funktion SHFormatDrive(...)

  SHFMT_OPT_QUICKFORMAT = $0000;     // Schnell-Formatierung ausfhren *
  SHFMT_OPT_FULL        = $0001;     // Vollstndige Formatierung
  SHFMT_OPT_SYSONLY     = $0002;     // Nur Kopien der Systemdateien anlegen

// Der mit * gekennzeichnete Wert ist nicht in der Ergnzung zum
// Microsoft Windows 95 SDK enthalten (Anm. des Autors).

// Rckgabewerte der Funktion SHFormatDrive(...)

  SHFMT_ERROR           = $FFFFFFFF; // Formatierung fehlerhaft
  SHFMT_CANCEL          = $FFFFFFFE; // Formatierung abgebrochen
  SHFMT_NOFORMAT        = $FFFFFFFD; // Laufwerk kann nicht formatiert werden

// Die Funktion SHFormatDrive gibt einen Wert fr das physikalische Format oder
// einen der vorstehend aufgefhrten Fehlerwerte zurck.
// Sofern ein Wert fr das physikalische Format zurckgegeben wird, knnen die
// niederwertigen 16 Bits in einem nachfolgenden Aufruf an den Parameter fmtID
// bergeben werden. Fr diesen Dialog ist kein Subclassing mglich, es knnen
// auch keine benutzerdfinierten Kontrollelemente eingefgt oder die Anzahl der
// zu formatierenden Disketten eingeschrnkt werden.

function SHFormatDrive(hWnd : HWND; Drive, fmtID, Options : Word) : Longint; stdcall;

implementation

const

  Shell32 = 'Shell32.dll';

function SHFormatDrive; external Shell32 name 'SHFormatDrive';

end.

